/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         CFG_STYPE
#define YYLTYPE         CFG_LTYPE
/* Substitute the variable and function names.  */
#define yyparse         cfg_parse
#define yylex           cfg_lex
#define yyerror         cfg_error
#define yydebug         cfg_debug
#define yynerrs         cfg_nerrs
#define yylval          cfg_lval
#define yychar          cfg_char
#define yylloc          cfg_lloc

/* First part of user prologue.  */
#line 2 "CNestedDataFile/cfg.y"


/*
 * Copyright (C) 2002 - David W. Durham
 *
 * This file is not part of any particular application.
 *
 * CNestedDataFile is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * CNestedDataFile is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 */

/*
 * As well as parsing CNestedDataFile data files, this is also used on the
 * side by string_to_anytype<vector> to parse a string and create a vector
 * of values from it.
 *
 * s2at means string_to_anytype used below.  Anything with this in front can be
 * ignored when maintaining this code for its primary use (parsing data files)
 *
 * Just adding this to be able to reuse this yacc file for string_to_anytype<vector>()
 * Since the generated yacc parser uses global variables, it's would cause a problem
 * if the string_to_anytype<vector>() function were called while it was parsing an actual
 * datafile... But, currently I see no reason for that to happen (unless I one day
 * implement array subscripting in the arithmetic expression stuff.)
 */
#include "config/common.h"

#include <math.h>
#include <string.h>

#include <stack>
#include <stdexcept>

#include "src/misc/CNestedDataFile/CNestedDataFile.h"
#include "src/misc/CNestedDataFile/anytype.h"
#include "src/misc/CNestedDataFile/cfg_types.h"

using namespace std;

#define YYLSP_NEEDED 1
#define YYERROR_VERBOSE

stack<string> cfg_scopeStack;

void cfg_error(int line,const char *msg);
void cfg_error(const CFG_LTYPE &pos,const char *msg);
void cfg_error(const char *msg);

int cfg_lex();

void cfg_init();
void cfg_deinit();

void cfg_includeFile(const char *filename);

void checkForDupMember(int line,const char *key);

static const string getCurrentScope();

int mycfg_nerrs=0;
extern string currentFilename;

#define VERIFY_TYPE(ap,a)				\
	if(a->type!=CNestedDataFile::ktValue)		\
		cfg_error(ap,"invalid operand; value type expected");

#define BINARY_EXPR(r,ap,a,bp,b,o)	\
	VERIFY_TYPE(ap,a)		\
	VERIFY_TYPE(bp,b)		\
	r=a;				\
	double x1,x2;			\
	r->stringValue = strdup( anytype_to_string<double>(string_to_anytype<double>(r->stringValue,x1) o string_to_anytype<double>(b->stringValue,x2)).c_str() );	\
	delete b;



#line 169 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_IDENT = 3,                      /* IDENT  */
  YYSYMBOL_LIT_NUMBER = 4,                 /* LIT_NUMBER  */
  YYSYMBOL_LIT_STRING = 5,                 /* LIT_STRING  */
  YYSYMBOL_TRUE = 6,                       /* TRUE  */
  YYSYMBOL_FALSE = 7,                      /* FALSE  */
  YYSYMBOL_INCLUDE = 8,                    /* INCLUDE  */
  YYSYMBOL_GETTEXT = 9,                    /* GETTEXT  */
  YYSYMBOL_NE = 10,                        /* NE  */
  YYSYMBOL_EQ = 11,                        /* EQ  */
  YYSYMBOL_GE = 12,                        /* GE  */
  YYSYMBOL_LE = 13,                        /* LE  */
  YYSYMBOL_OR = 14,                        /* OR  */
  YYSYMBOL_AND = 15,                       /* AND  */
  YYSYMBOL_16_ = 16,                       /* '~'  */
  YYSYMBOL_17_ = 17,                       /* '{'  */
  YYSYMBOL_18_ = 18,                       /* '}'  */
  YYSYMBOL_19_ = 19,                       /* ';'  */
  YYSYMBOL_20_ = 20,                       /* '['  */
  YYSYMBOL_21_ = 21,                       /* ']'  */
  YYSYMBOL_22_ = 22,                       /* '='  */
  YYSYMBOL_23_ = 23,                       /* ','  */
  YYSYMBOL_24_ = 24,                       /* '('  */
  YYSYMBOL_25_ = 25,                       /* ')'  */
  YYSYMBOL_26_ = 26,                       /* '+'  */
  YYSYMBOL_27_ = 27,                       /* '-'  */
  YYSYMBOL_28_ = 28,                       /* '*'  */
  YYSYMBOL_29_ = 29,                       /* '/'  */
  YYSYMBOL_30_ = 30,                       /* '%'  */
  YYSYMBOL_31_ = 31,                       /* '<'  */
  YYSYMBOL_32_ = 32,                       /* '>'  */
  YYSYMBOL_33_ = 33,                       /* '?'  */
  YYSYMBOL_34_ = 34,                       /* ':'  */
  YYSYMBOL_35_ = 35,                       /* '|'  */
  YYSYMBOL_YYACCEPT = 36,                  /* $accept  */
  YYSYMBOL_init = 37,                      /* init  */
  YYSYMBOL_start = 38,                     /* start  */
  YYSYMBOL_scope = 39,                     /* scope  */
  YYSYMBOL_40_1 = 40,                      /* $@1  */
  YYSYMBOL_scope_body = 41,                /* scope_body  */
  YYSYMBOL_opt_old_array = 42,             /* opt_old_array  */
  YYSYMBOL_scope_body_item = 43,           /* scope_body_item  */
  YYSYMBOL_array_body = 44,                /* array_body  */
  YYSYMBOL_array_body2 = 45,               /* array_body2  */
  YYSYMBOL_primary_expr = 46,              /* primary_expr  */
  YYSYMBOL_unary_expr = 47,                /* unary_expr  */
  YYSYMBOL_multiplicative_expr = 48,       /* multiplicative_expr  */
  YYSYMBOL_additive_expr = 49,             /* additive_expr  */
  YYSYMBOL_relational_expr = 50,           /* relational_expr  */
  YYSYMBOL_equality_expr = 51,             /* equality_expr  */
  YYSYMBOL_logical_and_expr = 52,          /* logical_and_expr  */
  YYSYMBOL_logical_or_expr = 53,           /* logical_or_expr  */
  YYSYMBOL_conditional_expr = 54,          /* conditional_expr  */
  YYSYMBOL_expr = 55,                      /* expr  */
  YYSYMBOL_qualified_ident = 56,           /* qualified_ident  */
  YYSYMBOL_s2at_array_body = 57,           /* s2at_array_body  */
  YYSYMBOL_s2at_array_body2 = 58,          /* s2at_array_body2  */
  YYSYMBOL_s2at_array_item = 59            /* s2at_array_item  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined CFG_LTYPE_IS_TRIVIAL && CFG_LTYPE_IS_TRIVIAL \
             && defined CFG_STYPE_IS_TRIVIAL && CFG_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   166

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  24
/* YYNRULES -- Number of rules.  */
#define YYNRULES  65
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  105

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   270


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    30,     2,     2,
      24,    25,    28,    26,    23,    27,     2,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    34,    19,
      31,    22,    32,    33,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    20,     2,    21,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    17,    35,    18,    16,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15
};

#if CFG_DEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   142,   142,   146,   153,   163,   162,   178,   179,   182,
     183,   193,   194,   198,   200,   211,   216,   220,   224,   235,
     241,   253,   257,   268,   273,   278,   284,   288,   294,   301,
     334,   341,   350,   352,   363,   378,   379,   380,   381,   386,
     387,   388,   393,   394,   395,   396,   397,   401,   402,   403,
     407,   408,   412,   413,   418,   419,   424,   430,   434,   449,
     450,   451,   455,   460,   469,   470
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if CFG_DEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "IDENT", "LIT_NUMBER",
  "LIT_STRING", "TRUE", "FALSE", "INCLUDE", "GETTEXT", "NE", "EQ", "GE",
  "LE", "OR", "AND", "'~'", "'{'", "'}'", "';'", "'['", "']'", "'='",
  "','", "'('", "')'", "'+'", "'-'", "'*'", "'/'", "'%'", "'<'", "'>'",
  "'?'", "':'", "'|'", "$accept", "init", "start", "scope", "$@1",
  "scope_body", "opt_old_array", "scope_body_item", "array_body",
  "array_body2", "primary_expr", "unary_expr", "multiplicative_expr",
  "additive_expr", "relational_expr", "equality_expr", "logical_and_expr",
  "logical_or_expr", "conditional_expr", "expr", "qualified_ident",
  "s2at_array_body", "s2at_array_body2", "s2at_array_item", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-24)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-8)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -24,   144,    17,   -12,     2,    18,   -24,   -24,   -24,     5,
     -24,    38,    55,   -24,   -24,   -24,   -24,   -24,   -24,   -24,
     -24,   -24,     0,    35,   -24,    62,   132,   132,   -24,   -24,
     -24,    20,   -11,    15,    46,    28,   -13,   -24,   -24,    29,
      -5,   -24,   -24,    49,    54,   -24,    77,   -24,   -24,     7,
     -24,    58,    59,   -24,   -24,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,    82,
     -24,    89,   147,   -24,   132,    66,   -24,   116,   -24,   -24,
     -24,   -24,   -24,    20,    20,   -11,   -11,   -11,   -11,    15,
      15,    46,    28,    53,   -24,   -24,   143,    78,   -24,   -24,
     -24,   132,   -24,   -24,   -24
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     0,    10,     0,     3,     1,     9,    61,     0,
       4,    11,     0,    16,    13,     8,    65,    57,    23,    24,
      26,    27,     0,     0,    59,     0,     0,     0,    28,    32,
      35,    39,    42,    47,    50,    52,    54,    56,    64,    29,
       0,    62,     5,     0,     0,    15,     0,    21,    17,     0,
      19,     0,     0,    33,    34,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      60,     0,     0,    12,     0,     0,    18,     0,    31,    30,
      36,    37,    38,    40,    41,    44,    43,    45,    46,    49,
      48,    51,    53,     0,    58,    63,     0,     0,    25,    22,
      20,     0,     6,    14,    55
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -24,   -24,   -24,   -24,   -24,    27,   -24,   -24,   -24,   -24,
     -24,   -22,    19,    12,    16,    34,    36,   -24,     1,   -23,
     -24,   -24,   -24,    30
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,     2,    14,    72,     5,    44,    15,    28,    49,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    10,    40,    41
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      50,    67,    52,     8,    53,    54,    16,     7,    17,    18,
      19,    20,    21,    70,    22,    58,    59,     6,    71,     9,
      68,    11,    23,    24,    46,    76,    12,    60,    61,    25,
      77,    26,    27,    80,    81,    82,    47,    13,    17,    18,
      19,    20,    21,    66,    22,    93,    62,    63,    55,    56,
      57,    97,    23,    48,   100,    42,    64,    65,    43,    25,
      45,    26,    27,    51,    69,    17,    18,    19,    20,    21,
      73,    22,    85,    86,    87,    88,    74,    83,    84,    23,
      89,    90,    75,    78,    79,    94,    25,   101,    26,    27,
      16,    98,    17,    18,    19,    20,    21,   103,    22,    96,
      91,    95,   104,    92,     0,     0,    23,     0,     0,     0,
       0,     0,     0,    25,     0,    26,    27,    99,     0,    17,
      18,    19,    20,    21,     0,    22,     0,     0,     0,     0,
       0,     0,     0,    23,     0,    17,    18,    19,    20,    21,
      25,    22,    26,    27,    -7,     3,    11,    -7,     3,    23,
      -7,    12,    -7,     0,     0,    -7,    25,     0,    26,    27,
       4,   102,    13,    -7,     0,    -7,    -7
};

static const yytype_int8 yycheck[] =
{
      23,    14,    25,     1,    26,    27,     1,    19,     3,     4,
       5,     6,     7,    18,     9,    26,    27,     0,    23,    17,
      33,     3,    17,    18,    24,    18,     8,    12,    13,    24,
      23,    26,    27,    55,    56,    57,     1,    19,     3,     4,
       5,     6,     7,    15,     9,    68,    31,    32,    28,    29,
      30,    74,    17,    18,    77,    17,    10,    11,    20,    24,
       5,    26,    27,     1,    35,     3,     4,     5,     6,     7,
      21,     9,    60,    61,    62,    63,    22,    58,    59,    17,
      64,    65,     5,    25,    25,     3,    24,    34,    26,    27,
       1,    25,     3,     4,     5,     6,     7,    19,     9,    72,
      66,    71,   101,    67,    -1,    -1,    17,    -1,    -1,    -1,
      -1,    -1,    -1,    24,    -1,    26,    27,     1,    -1,     3,
       4,     5,     6,     7,    -1,     9,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    17,    -1,     3,     4,     5,     6,     7,
      24,     9,    26,    27,     0,     1,     3,     3,     1,    17,
       3,     8,     8,    -1,    -1,     8,    24,    -1,    26,    27,
      16,    18,    19,    19,    -1,    18,    19
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    37,    38,     1,    16,    41,     0,    19,     1,    17,
      57,     3,     8,    19,    39,    43,     1,     3,     4,     5,
       6,     7,     9,    17,    18,    24,    26,    27,    44,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      58,    59,    17,    20,    42,     5,    24,     1,    18,    45,
      55,     1,    55,    47,    47,    28,    29,    30,    26,    27,
      12,    13,    31,    32,    10,    11,    15,    14,    33,    35,
      18,    23,    40,    21,    22,     5,    18,    23,    25,    25,
      47,    47,    47,    48,    48,    49,    49,    49,    49,    50,
      50,    51,    52,    55,     3,    59,    41,    55,    25,     1,
      55,    34,    18,    19,    54
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    36,    37,    38,    38,    40,    39,    41,    41,    41,
      41,    42,    42,    43,    43,    43,    43,    44,    44,    45,
      45,    45,    45,    46,    46,    46,    46,    46,    46,    46,
      46,    46,    47,    47,    47,    48,    48,    48,    48,    49,
      49,    49,    50,    50,    50,    50,    50,    51,    51,    51,
      52,    52,    53,    53,    54,    54,    55,    56,    56,    57,
      57,    57,    58,    58,    59,    59
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     3,     0,     5,     0,     2,     2,
       1,     0,     2,     1,     5,     2,     1,     2,     3,     1,
       3,     1,     3,     1,     1,     4,     1,     1,     1,     1,
       3,     3,     1,     2,     2,     1,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     3,     1,     3,     3,
       1,     3,     1,     3,     1,     5,     1,     1,     3,     2,
       3,     1,     1,     3,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = CFG_EMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == CFG_EMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use CFG_error or CFG_UNDEF. */
#define YYERRCODE CFG_UNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if CFG_DEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined CFG_LTYPE_IS_TRIVIAL && CFG_LTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !CFG_DEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !CFG_DEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined CFG_LTYPE_IS_TRIVIAL && CFG_LTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = CFG_EMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == CFG_EMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= CFG_EOF)
    {
      yychar = CFG_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == CFG_error)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = CFG_UNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = CFG_EMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* init: %empty  */
#line 142 "CNestedDataFile/cfg.y"
                      { cfg_init(); }
#line 1411 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 3: /* start: init scope_body  */
#line 147 "CNestedDataFile/cfg.y"
        {
		cfg_deinit();

		return mycfg_nerrs!=0;
	}
#line 1421 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 4: /* start: init '~' s2at_array_body  */
#line 154 "CNestedDataFile/cfg.y"
        {
		cfg_deinit();
		return mycfg_nerrs!=0;
	}
#line 1430 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 5: /* $@1: %empty  */
#line 163 "CNestedDataFile/cfg.y"
        { /* mid-rule action */

		checkForDupMember((yylsp[-1]).first_line,(yyvsp[-1].stringValue));

		cfg_scopeStack.push((yyvsp[-1].stringValue));

		free((yyvsp[-1].stringValue));

		/* now continue parsing for new scope's body */
	}
#line 1445 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 6: /* scope: IDENT '{' $@1 scope_body '}'  */
#line 172 "CNestedDataFile/cfg.y"
                         {
		cfg_scopeStack.pop();
	}
#line 1453 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 14: /* scope_body_item: IDENT opt_old_array '=' expr ';'  */
#line 201 "CNestedDataFile/cfg.y"
        {
		checkForDupMember((yylsp[-4]).first_line,(yyvsp[-4].stringValue));
		if((yyvsp[-1].variant)->type==CNestedDataFile::ktValue)
			CNestedDataFile::parseTree->prvCreateKey(getCurrentScope()+(yyvsp[-4].stringValue),0,*(yyvsp[-1].variant),CNestedDataFile::parseTree->root);
		else
			yyerror((yylsp[-2]),"assigning an invalid typed value to an identifier");

		delete (yyvsp[-1].variant);
		free((yyvsp[-4].stringValue));
	}
#line 1468 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 15: /* scope_body_item: INCLUDE LIT_STRING  */
#line 212 "CNestedDataFile/cfg.y"
        {
		cfg_includeFile((yyvsp[0].stringValue));
		free((yyvsp[0].stringValue));
	}
#line 1477 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 17: /* array_body: '{' '}'  */
#line 221 "CNestedDataFile/cfg.y"
        {
		(yyval.stringValue)=strdup("{}");
	}
#line 1485 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 18: /* array_body: '{' array_body2 '}'  */
#line 225 "CNestedDataFile/cfg.y"
        {
		(yyval.stringValue)=(char *)malloc((1+strlen((yyvsp[-1].stringValue))+1)+1);
		strcpy((yyval.stringValue),"{");
		strcat((yyval.stringValue),(yyvsp[-1].stringValue));
		strcat((yyval.stringValue),"}");
		free((yyvsp[-1].stringValue));
	}
#line 1497 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 19: /* array_body2: expr  */
#line 236 "CNestedDataFile/cfg.y"
        {
		(yyval.stringValue)=strdup((yyvsp[0].variant)->stringValue.c_str());
		delete (yyvsp[0].variant);
	}
#line 1506 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 20: /* array_body2: array_body2 ',' expr  */
#line 242 "CNestedDataFile/cfg.y"
        {
		(yyval.stringValue)=(char *)malloc((strlen((yyvsp[-2].stringValue))+1+(yyvsp[0].variant)->stringValue.size())+1);
		strcpy((yyval.stringValue),(yyvsp[-2].stringValue));
		strcat((yyval.stringValue),",");
		strcat((yyval.stringValue),(yyvsp[0].variant)->stringValue.c_str());

		free((yyvsp[-2].stringValue));
		delete (yyvsp[0].variant);
	}
#line 1520 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 21: /* array_body2: error  */
#line 254 "CNestedDataFile/cfg.y"
        {
		(yyval.stringValue)=strdup("");
	}
#line 1528 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 22: /* array_body2: array_body2 ',' error  */
#line 258 "CNestedDataFile/cfg.y"
        {
		(yyval.stringValue)=(yyvsp[-2].stringValue);
	}
#line 1536 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 23: /* primary_expr: LIT_NUMBER  */
#line 269 "CNestedDataFile/cfg.y"
        {
		(yyval.variant)=new CNestedDataFile::CVariant((yyvsp[0].stringValue));
		free((yyvsp[0].stringValue));
	}
#line 1545 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 24: /* primary_expr: LIT_STRING  */
#line 274 "CNestedDataFile/cfg.y"
        {
		(yyval.variant)=new CNestedDataFile::CVariant(anytype_to_string<string>((yyvsp[0].stringValue)));
		free((yyvsp[0].stringValue));
	}
#line 1554 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 25: /* primary_expr: GETTEXT '(' LIT_STRING ')'  */
#line 279 "CNestedDataFile/cfg.y"
        {
		/* having gettext(...) around a string simply causes an entry to be created in the rezound.pot file */
		(yyval.variant)=new CNestedDataFile::CVariant(anytype_to_string<string>((yyvsp[-1].stringValue)));
		free((yyvsp[-1].stringValue));
	}
#line 1564 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 26: /* primary_expr: TRUE  */
#line 285 "CNestedDataFile/cfg.y"
        {
		(yyval.variant)=new CNestedDataFile::CVariant("true");
	}
#line 1572 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 27: /* primary_expr: FALSE  */
#line 289 "CNestedDataFile/cfg.y"
        {
		(yyval.variant)=new CNestedDataFile::CVariant("false");
	}
#line 1580 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 28: /* primary_expr: array_body  */
#line 295 "CNestedDataFile/cfg.y"
        {
		(yyval.variant)=new CNestedDataFile::CVariant((yyvsp[0].stringValue));
		free((yyvsp[0].stringValue));
	}
#line 1589 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 29: /* primary_expr: qualified_ident  */
#line 302 "CNestedDataFile/cfg.y"
        {
		if(CNestedDataFile::parseTree==NULL)
		{
			(yyval.variant)=new CNestedDataFile::CVariant("");
		}
		else
		{
			CNestedDataFile::CVariant *value;
			if(!CNestedDataFile::parseTree->findVariantNode(value,(yyvsp[0].stringValue),0,false,CNestedDataFile::parseTree->root))
			{
				cfg_error((yylsp[0]),("symbol not found: '"+string((yyvsp[0].stringValue))+"'").c_str());
				value=new CNestedDataFile::CVariant("");
			}

			switch(value->type)
			{
			case CNestedDataFile::ktValue:
				(yyval.variant)=new CNestedDataFile::CVariant(value->stringValue);
				break;
			case CNestedDataFile::ktScope:
				cfg_error((yylsp[0]),("symbol resolves to a scope: '"+string((yyvsp[0].stringValue))+"'").c_str());
				value=new CNestedDataFile::CVariant("");
				break;
			default:
				throw runtime_error("cfg_parse -- unhandled variant type");
			}
		}

		free((yyvsp[0].stringValue));
	}
#line 1624 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 30: /* primary_expr: '(' expr ')'  */
#line 335 "CNestedDataFile/cfg.y"
        {
		(yyval.variant)=(yyvsp[-1].variant);
	}
#line 1632 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 31: /* primary_expr: '(' error ')'  */
#line 342 "CNestedDataFile/cfg.y"
        {
		yyclearin;
		(yyval.variant)=new CNestedDataFile::CVariant("");
	}
#line 1641 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 32: /* unary_expr: primary_expr  */
#line 350 "CNestedDataFile/cfg.y"
                       { (yyval.variant)=(yyvsp[0].variant); }
#line 1647 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 33: /* unary_expr: '+' unary_expr  */
#line 353 "CNestedDataFile/cfg.y"
        {
		(yyval.variant)=(yyvsp[0].variant);
		if((yyvsp[0].variant)->type!=CNestedDataFile::ktValue)
			cfg_error((yylsp[0]),"invalid operand");
		else
		{
			double x;
			(yyval.variant)->stringValue=strdup(anytype_to_string<double>(+string_to_anytype<double>((yyval.variant)->stringValue,x)).c_str());
		}
	}
#line 1662 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 34: /* unary_expr: '-' unary_expr  */
#line 364 "CNestedDataFile/cfg.y"
        {
		(yyval.variant)=(yyvsp[0].variant);
		if((yyvsp[0].variant)->type!=CNestedDataFile::ktValue)
			cfg_error((yylsp[0]),"invalid operand");
		else
		{
			double x;
			(yyval.variant)->stringValue=strdup(anytype_to_string<double>(-string_to_anytype<double>((yyval.variant)->stringValue,x)).c_str());
		}
	}
#line 1677 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 35: /* multiplicative_expr: unary_expr  */
#line 378 "CNestedDataFile/cfg.y"
                     { (yyval.variant)=(yyvsp[0].variant); }
#line 1683 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 36: /* multiplicative_expr: multiplicative_expr '*' unary_expr  */
#line 379 "CNestedDataFile/cfg.y"
                                             { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),*) }
#line 1689 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 37: /* multiplicative_expr: multiplicative_expr '/' unary_expr  */
#line 380 "CNestedDataFile/cfg.y"
                                             { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),/) }
#line 1695 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 38: /* multiplicative_expr: multiplicative_expr '%' unary_expr  */
#line 381 "CNestedDataFile/cfg.y"
                                             { double x1,x2; VERIFY_TYPE((yylsp[-2]),(yyvsp[-2].variant)) VERIFY_TYPE((yylsp[0]),(yyvsp[0].variant)) (yyval.variant)=(yyvsp[-2].variant); (yyval.variant)->stringValue= strdup( anytype_to_string<double>(fmod(string_to_anytype<double>((yyval.variant)->stringValue,x1),string_to_anytype<double>((yyvsp[0].variant)->stringValue,x2))).c_str() ); delete (yyvsp[0].variant); }
#line 1701 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 39: /* additive_expr: multiplicative_expr  */
#line 386 "CNestedDataFile/cfg.y"
                              { (yyval.variant)=(yyvsp[0].variant); }
#line 1707 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 40: /* additive_expr: additive_expr '+' multiplicative_expr  */
#line 387 "CNestedDataFile/cfg.y"
                                                { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),+) }
#line 1713 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 41: /* additive_expr: additive_expr '-' multiplicative_expr  */
#line 388 "CNestedDataFile/cfg.y"
                                                { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),-) }
#line 1719 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 42: /* relational_expr: additive_expr  */
#line 393 "CNestedDataFile/cfg.y"
                        { (yyval.variant)=(yyvsp[0].variant); }
#line 1725 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 43: /* relational_expr: relational_expr LE additive_expr  */
#line 394 "CNestedDataFile/cfg.y"
                                           { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),<=) }
#line 1731 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 44: /* relational_expr: relational_expr GE additive_expr  */
#line 395 "CNestedDataFile/cfg.y"
                                           { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),>=) }
#line 1737 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 45: /* relational_expr: relational_expr '<' additive_expr  */
#line 396 "CNestedDataFile/cfg.y"
                                            { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),<) }
#line 1743 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 46: /* relational_expr: relational_expr '>' additive_expr  */
#line 397 "CNestedDataFile/cfg.y"
                                            { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),>) }
#line 1749 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 47: /* equality_expr: relational_expr  */
#line 401 "CNestedDataFile/cfg.y"
                          { (yyval.variant)=(yyvsp[0].variant); }
#line 1755 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 48: /* equality_expr: equality_expr EQ relational_expr  */
#line 402 "CNestedDataFile/cfg.y"
                                           { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),==) }
#line 1761 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 49: /* equality_expr: equality_expr NE relational_expr  */
#line 403 "CNestedDataFile/cfg.y"
                                           { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),!=) }
#line 1767 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 50: /* logical_and_expr: equality_expr  */
#line 407 "CNestedDataFile/cfg.y"
                        { (yyval.variant)=(yyvsp[0].variant); }
#line 1773 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 51: /* logical_and_expr: logical_and_expr AND equality_expr  */
#line 408 "CNestedDataFile/cfg.y"
                                             { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),&&) }
#line 1779 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 52: /* logical_or_expr: logical_and_expr  */
#line 412 "CNestedDataFile/cfg.y"
                           { (yyval.variant)=(yyvsp[0].variant); }
#line 1785 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 53: /* logical_or_expr: logical_or_expr OR logical_and_expr  */
#line 413 "CNestedDataFile/cfg.y"
                                              { BINARY_EXPR((yyval.variant),(yylsp[-2]),(yyvsp[-2].variant),(yylsp[0]),(yyvsp[0].variant),||) }
#line 1791 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 54: /* conditional_expr: logical_or_expr  */
#line 418 "CNestedDataFile/cfg.y"
                          { (yyval.variant)=(yyvsp[0].variant); }
#line 1797 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 55: /* conditional_expr: logical_or_expr '?' expr ':' conditional_expr  */
#line 419 "CNestedDataFile/cfg.y"
                                                        { double x; VERIFY_TYPE((yylsp[-4]),(yyvsp[-4].variant)) (yyval.variant)=(string_to_anytype<double>((yyvsp[-4].variant)->stringValue,x) ? ((delete (yyvsp[0].variant)),(yyvsp[-2].variant)) : ((delete (yyvsp[-2].variant)),(yyvsp[0].variant))); delete (yyvsp[-4].variant); }
#line 1803 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 56: /* expr: conditional_expr  */
#line 424 "CNestedDataFile/cfg.y"
                           { (yyval.variant)=(yyvsp[0].variant); }
#line 1809 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 57: /* qualified_ident: IDENT  */
#line 431 "CNestedDataFile/cfg.y"
        {
		(yyval.stringValue)=(yyvsp[0].stringValue);
	}
#line 1817 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 58: /* qualified_ident: qualified_ident '|' IDENT  */
#line 435 "CNestedDataFile/cfg.y"
        {
		(yyval.stringValue)=(char *)realloc((yyval.stringValue),strlen((yyval.stringValue))+1+strlen((yyvsp[0].stringValue))+1);
		strcat((yyval.stringValue),CNestedDataFile::delim.c_str());
		strcat((yyval.stringValue),(yyvsp[0].stringValue));

		free((yyvsp[0].stringValue));
	}
#line 1829 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 59: /* s2at_array_body: '{' '}'  */
#line 449 "CNestedDataFile/cfg.y"
                                        {}
#line 1835 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 60: /* s2at_array_body: '{' s2at_array_body2 '}'  */
#line 450 "CNestedDataFile/cfg.y"
                                        {}
#line 1841 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 61: /* s2at_array_body: error  */
#line 451 "CNestedDataFile/cfg.y"
                                        { YYABORT; }
#line 1847 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 62: /* s2at_array_body2: s2at_array_item  */
#line 456 "CNestedDataFile/cfg.y"
        {
		CNestedDataFile::s2at_return_value.push_back((yyvsp[0].variant)->stringValue);
		delete (yyvsp[0].variant);
	}
#line 1856 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 63: /* s2at_array_body2: s2at_array_body2 ',' s2at_array_item  */
#line 461 "CNestedDataFile/cfg.y"
        {
		CNestedDataFile::s2at_return_value.push_back((yyvsp[0].variant)->stringValue);
		delete (yyvsp[0].variant);
	}
#line 1865 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 64: /* s2at_array_item: expr  */
#line 469 "CNestedDataFile/cfg.y"
                { (yyval.variant)=(yyvsp[0].variant); }
#line 1871 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;

  case 65: /* s2at_array_item: error  */
#line 470 "CNestedDataFile/cfg.y"
                { YYABORT; }
#line 1877 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"
    break;


#line 1881 "/builddir/build/BUILD/rezound-0.13.1.4d2e1d0-build/rezound-4d2e1d0065b6948462995fe80b952291363097a6/redhat-linux-build/src/misc/cfg.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == CFG_EMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= CFG_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == CFG_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = CFG_EMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != CFG_EMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 474 "CNestedDataFile/cfg.y"


void cfg_error(int line,const char *msg)
{
	mycfg_nerrs++;

	if(CNestedDataFile::s2at_string.size()>0)
		// suppress error messages when in s2at mode
		return;

	fprintf(stderr,"%s:%d: %s\n",currentFilename.c_str(),line,msg);

	if(mycfg_nerrs>25)
		throw runtime_error("cfg_error -- more than 25 errors; bailing");
}

void cfg_error(const RTokenPosition &pos,const char *msg)
{
	cfg_error(pos.first_line,msg);
}

void cfg_error(const char *msg)
{
	cfg_error(yylloc.first_line,msg);
}

void checkForDupMember(int line,const char *key)
{
	if(CNestedDataFile::parseTree->keyExists(getCurrentScope()+key))
		cfg_error(line,("duplicate scope name: "+(getCurrentScope()+string(key))).c_str());
}

static const string getCurrentScope()
{
	stack<string> copy=cfg_scopeStack;
	string s;
	while(!copy.empty())
	{
		s=copy.top()+s;
		s=CNestedDataFile::delim+s;
		copy.pop();
	}

	s+=CNestedDataFile::delim;

	s.erase(0,1);

	return s;
}




